var map = L.map('mapid', {
    center : [lat,long],
    minZoom : 3,
    zoom : zoom
});

L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
{
    attribution: 'Develop by <a href="https://fudugo.com">FuduGo</a>',
    subdomains: ['a','b','c']
}).addTo(map);

var fs_marker = '';

function add_marker(lat,lon){
    // map.removeLayer(fs_marker);
    if(fs_marker != ''){
        map.removeLayer(fs_marker);
    }
    map.setView(new L.LatLng(lat,lon), 6, {"animate": true, "pan": { "duration": 2 }}); 

    if(icon != ''){
        var fs_icon = L.icon({
            iconUrl: icon,
            shadowUrl: '',
            iconAnchor:   [12, 40], // point of the icon which will correspond to marker's location
            popupAnchor:  [-2, -35] // point from which the popup should open relative to the iconAnchor
        });
        fs_marker = L.marker([lat,lon], {icon: fs_icon}).addTo(map);
    }else{
        fs_marker = L.marker([lat,lon]).addTo(map);
    }
}



/* Get Geo Loction coordinate by simply passing address */
function getGeoCoordinate(address, fsCoordinates = null){
    /* Record User Geo-Coordinates from address */      
    jQuery.get(location.protocol + '//nominatim.openstreetmap.org/search?format=json&postalcode='+address, function(data){
        if(data.length > 0){
            fsCoordinates(data[0].lat,data[0].lon);
        }else{
            fsCoordinates('','')
        }
    }); 
}

$(document).on('click','#fs-geo-locator-button',function(){
    var zip = jQuery('._fs_zip').val();
    if(zip != ''){
        getGeoCoordinate(zip,function(lat,lon){
            if(lat != '' && lon != ''){
                jQuery('.lat').val(lat);
                jQuery('.lon').val(lon);
                add_marker(lat,lon);
            }else{
                jQuery('html, body').animate({
                    scrollTop: ($("._fs_zip").offset().top)-60
                }, 1000);
                jQuery('.zip_error').attr('style','color:red;font-size:14px;');
                jQuery('.zip_error').text('Location not found, Please use valid zip code.');
                setTimeout(function(){ $('.zip_error').attr('style','display:none');; }, 3000);
            }
        });
    }else{
        jQuery('html, body').animate({
            scrollTop: ($("._fs_zip").offset().top)-60
        }, 1000);
        jQuery('.zip_error').attr('style','color:red;font-size:14px;');
        jQuery('.zip_error').text('Zip code is required.');
        setTimeout(function(){ $('.zip_error').attr('style','display:none');; }, 3000);
    }
});

$(document).ready(function(){
    var lat = jQuery('.lat').val();
    var lon = jQuery('.lon').val();
    if(lat != '' && lon != ''){
        add_marker(lat,lon);
    }
});