var map = L.map('mapid', {
    center : [lat,long],
    minZoom : 3,
    zoom : zoom
});

L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
{
    attribution: 'All rights reserved.',
    subdomains: ['a','b','c']
}).addTo(map);

checkForContractorAvilability(lat,long, 50); 

function searchByAjax(text, callResponse)//callback for 3rd party ajax requests
{
    var data = {
        'action': 'fs_search_by_leaflet',
        'data': {q: text}     
    };
    jQuery.post(url, data, function(response) {
        console.log(response);
        callResponse(response);
    });
}

// Search by zip
jQuery('button#fs-search-zip').click(function(){
    var zip_code = jQuery('#fs-search-form input#zip').val(); 
    jQuery('.fs-loader-div').show();
    getGeoCoordinate(zip_code, function(data){ 
        if(data.length > 0){
            var lat = data[0].lat;
            var lng = data[0].lon;  
            var radius = '50'; //Mi 

            map.flyTo([lat, lng], 8, {animate: true,duration: 2});
            //map.setView(new L.LatLng(lat, lng), 8, {"animate": true, "pan": { "duration": 2 }});
            var reply = checkForContractorAvilability(lat,lng, radius,true); 
            //console.log(reply);
        }else{
            checkForContractorAvilability();
        } 
    });
});

function checkForContractorAvilability(lat = null, lng = null, radius = null, msg = null){
    jQuery('.error-message').hide();
    jQuery('.store').remove();
    if(lat && lng && radius){
        fsAjaxCall('fs_search_by_zip', {'lat':lat, 'lng': lng, 'radius': radius }, function(data){
           var contractorData = jQuery.parseJSON(data); 
           if(contractorData.length > 0){
                jQuery.each( contractorData, function( key, value ) {
                    if(value.thumbnail != ''){
                        var thumbnail = '<img src="'+value.thumbnail+'" /><br>';
                    }else{
                        var thumbnail = '';
                    }
                    if(icon != ''){
                        var fs_icon = L.icon({
                            iconUrl: icon,
                            shadowUrl: '',
                            iconAnchor:   [12, 40], // point of the icon which will correspond to marker's location
                            popupAnchor:  [-2, -35] // point from which the popup should open relative to the iconAnchor
                        });
                        L.marker([value.lat,value.lon], {icon: fs_icon}).addTo(map).bindPopup(thumbnail+'<div class="fs-map-pop-content"><a href="'+value.link+'" target="_blank"><b>'+value.title+'</b></a><br>'+value.address+', '+value.state+', '+value.city+', '+value.zip+'</div>');
                    }else{
                        L.marker([value.lat,value.lon]).addTo(map).bindPopup(thumbnail+'<div class="fs-map-pop-content"><b>'+value.title+'</b><br>'+value.address+'</div>');
                    }
                    jQuery('.store-list').append('<div class="store store-'+value.id+'" onclick="javascript:highlightStore('+value.id+','+value.lat+','+value.lon+')">\n\
                                                <h5 class="store-name">'+value.title+'</h5>\n\
                                                <p class="store-address">'+value.address+'</p>\n\
                                                <p class="store-des">'+value.short_des+'</p>\n\
                                            </div>');
                });
                jQuery('.fs-loader-div').hide();
            }else{
                jQuery('.store').remove();
                jQuery('.fs-loader-div').hide();
                if(msg == true){
                    jQuery('.error-message').attr('style','display:block');
                    jQuery('.error-message').text('Data not found, Please try another zip code.');
                }
                //setTimeout(function(){ jQuery('.error-message').hide(); }, 3000);
           }
        });
    }else{
        jQuery('.store').remove();
        jQuery('.fs-loader-div').hide();
        if(msg == true){
            jQuery('.error-message').attr('style','display:block');
            jQuery('.error-message').text('Please Enter valid zip code.'); 
        }
        //setTimeout(function(){ jQuery('.error-message').hide(); }, 3000);
        //map.setView(new L.LatLng(geo_lat, geo_lon), 6, {"animate": true, "pan": { "duration": 2 }}); 
    }       
}


function highlightStore(id,lat,lon){
    jQuery('.store').removeClass('active-store');
    jQuery('.store-'+id).addClass('active-store');

    //map.setView(new L.LatLng(lat, lon), 14, {"animate": true, "pan": { "duration": 4 }}); 
    map.flyTo([lat, lon], 14, {
        animate: true,
        duration: 2
    });

}