<?php 
/*
* Plugin Name: Store Locator
* Description: Used by millions, Opensource Free Store Locator is quite possibly the best way in the 	world to <strong>locat your store on visualise map</strong>. It allow user to serach store by zip 	code and as admin you can add/edit store with information.
* Version: 1.0.1
* Author: Fudugo Team
* Setting: Setting
* Text Domain: swsl
*/

defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

include dirname( __FILE__ ) . '\includes\fs-admin-function.php';
include dirname( __FILE__ ) . '\includes\fs-view-function.php';

if(!defined('FS_BASE_URL')){
    define('FS_BASE_URL', plugin_dir_url(__FILE__));
}

if(!defined('FS_BASE_DIR')){
	define('FS_BASE_DIR', plugin_dir_path(__FILE__));	
}


//enqueue style and scripts if has shortcode
add_action('the_posts', 'fc_load_script_in_post' );

//Create Store Locator Custom Post
add_action('init', 'fs_store_locator');

//Create Store Locator Setting Menu
add_action( 'add_meta_boxes', 'fs_store_locator_add_meta_boxes');

//Use to save meta data
add_action('save_post', 'fs_save_meta');

//Create new sub menu
add_action('admin_menu', 'fs_register_setting_page');

if(!shortcode_exists( 'fs-store-locator' ) ) {
	add_shortcode( 'fs-store-locator', 'fs_store_locator_map' );
}

//Create Ajax Request
add_action( 'wp_ajax_fs_search_by_zip', 'fs_search_by_zip' );
add_action( 'wp_ajax_nopriv_fs_search_by_zip', 'fs_search_by_zip' );


//Create Ajax Request
add_action( 'wp_ajax_fs_search_by_leaflet', 'fs_search_by_leaflet' );

//Add Setting link
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'add_setting_action_links' );

// Add support link
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'add_support_action_links' );

//load script in admin page 
add_action( 'admin_enqueue_scripts', 'fc_load_script_in_admin'); 

