<?php 

//Function use for custome post type
if(!function_exists('fs_store_locator')){
	function fs_store_locator() {
		$labels = array(
			'name' => _x('Store Locator', 'post type general name'),
			'singular_name' => _x('store-locator', 'post type singular name'),
			'add_new' => _x('Add New Store', 'banner'),
			'add_new_item' => __('Add New Store','swsl'),
			'edit_item' => __('Edit Post','swsl'),
			'new_item' => __('New Post','swsl'),
			'view_item' => __('View Post','swsl'),
			'search_items' => __('Search Post','swsl'),
			'not_found' =>  __('Nothing found','swsl'),
			'not_found_in_trash' => __('Nothing found in Trash','swsl'),
			'parent_item_colon' => ''
		);
		$args = array(
			'labels' => $labels,
			'public' => true,
			'publicly_queryable' => true,
			'show_ui' => true,
			'query_var' => true,
			'menu_icon' => null,
			'rewrite' => true,
			'capability_type' => 'post',
			'hierarchical' => false,
			'menu_position' => null,
			'supports' => array('title','thumbnail','excerpt', 'custom-fields'),
			'menu_icon'           => 'dashicons-location-alt'
		); 
		register_post_type( 'store_locator' , $args );
	}
}

//check if shortcode is present or not
if(!function_exists('fc_load_script_in_post')){
	function fc_load_script_in_post($posts) {
		if ( empty($posts) || is_admin())
			return $posts;
		$found = false;
		foreach ($posts as $post) {
			if ( has_shortcode($post->post_content, 'fs-store-locator') ){
				$found = true;
				break;
			}
		}
		if ($found){
			wp_enqueue_script('jquery');

			wp_register_script('leaflet', FS_BASE_URL.'assets/js/leaflet.js' );
			wp_enqueue_script('leaflet','',array(),false,true);

			wp_register_script('fs-map', FS_BASE_URL.'assets/js/fs-map.js');
			wp_enqueue_script('fs-map','',array(),false,true);

			wp_register_style('fs-front-map', FS_BASE_URL.'assets/css/fs-map.css');
			wp_enqueue_style('fs-front-map');

			wp_register_style('leaflet', FS_BASE_URL.'assets/css/leaflet.css');
			wp_enqueue_style('leaflet');

			wp_register_script('view-map',FS_BASE_URL.'assets/js/map-view.js');
			wp_enqueue_script('view-map','',array(),false,true);
		}
		return $posts;
	}
}

//load script in admin page 
if(!function_exists('fc_load_script_in_admin')){
	function fc_load_script_in_admin( $hook ) { 
		global $post;  
	    if ( $hook == 'post-new.php' || $hook == 'post.php' ) {  
	        if ( 'store_locator' === $post->post_type ) { 
	        	wp_enqueue_script('jquery');

	        	wp_register_script('leaflet', FS_BASE_URL.'assets/js/leaflet.js');
	            wp_enqueue_script('leaflet','',array(),false,true);

	            wp_register_script('fs-map', FS_BASE_URL.'assets/js/fs-map.js');
				wp_enqueue_script('fs-map','',array(),false,true);

				wp_register_script('leaflet-search', FS_BASE_URL.'assets/js/leaflet-search.src.js');
				wp_enqueue_script('leaflet-search','',array(),false,true); 

				wp_register_style('leaflet', FS_BASE_URL.'assets/css/leaflet.css');
				wp_enqueue_style('leaflet');

				wp_register_style('leaflet-search', FS_BASE_URL.'assets/css/leaflet-search.src.css');
				wp_enqueue_style('leaflet-search');

				wp_register_style('fs-front-map', FS_BASE_URL.'assets/css/fs-map.css');
				wp_enqueue_style('fs-front-map');

				wp_register_script('admin-view-map', FS_BASE_URL.'assets/js/admin-map-view.js');
				wp_enqueue_script('admin-view-map','',array(),false,true);
	        }  
	    }  
	}  
}
//Use to create custome menu
if(!function_exists('fs_store_locator_add_meta_boxes')){
	function fs_store_locator_add_meta_boxes(){
		add_meta_box( 'Store Date','Store Data', 'fs_fields_meta_box_address', 'store_locator', 'advanced', 'default', null );
	}
}

//Use to save meta data
if(!function_exists('fs_save_meta')){
	function fs_save_meta( $post_id ) {
		 $post_type = get_post_type($post_id);
	    // If this isn't a 'book' post, don't update it.
	    if ( "store_locator" != $post_type ) return;
		if ( isset($_POST['_fs_address']) ) {        
			update_post_meta($post_id, '_fs_address', sanitize_text_field( $_POST['_fs_address']));      
		}  
		if ( isset($_POST['_fs_city']) ) {        
			update_post_meta($post_id, '_fs_city', sanitize_text_field( $_POST['_fs_city']));      
		}  
		if ( isset($_POST['_fs_state']) ) {        
			update_post_meta($post_id, '_fs_state', sanitize_text_field( $_POST['_fs_state']));      
		}  
		if ( isset($_POST['_fs_zip']) ) {        
			update_post_meta($post_id, '_fs_zip', sanitize_text_field( $_POST['_fs_zip']));      
		}  
		if ( isset($_POST['_fs_lat']) ) {        
			update_post_meta($post_id, '_fs_lat', sanitize_text_field( $_POST['_fs_lat'] ));      
		}
		if ( isset($_POST['_fs_long']) ) {        
			update_post_meta($post_id, '_fs_long',  sanitize_text_field($_POST['_fs_long']));      
		}
		if ( isset($_POST['_fs_short_des']) ) {        
			update_post_meta($post_id, '_fs_short_des',  sanitize_text_field($_POST['_fs_short_des']));      
		}
		if ( isset($_POST['_fs_link']) ) {        
			update_post_meta($post_id, '_fs_link',  sanitize_text_field($_POST['_fs_link']));      
		}
	}
}

//use to new sub menu
if(!function_exists('fs_register_setting_page')){ 
	function fs_register_setting_page() {
	  add_submenu_page( 'edit.php?post_type=store_locator', 'Setting', 'Setting', 'manage_options', 'store-locator-setting', 'fs_store_locator_setting' ); 
	}
}

//use to calculate distance between two lat long points
if(!function_exists('distance')){
	function fs_distance($lat1, $lon1, $lat2, $lon2, $unit) {
		$theta = $lon1 - $lon2;
		$dist  = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) +  cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
		$dist  = acos($dist);
		$dist  = rad2deg($dist);
		$miles = $dist * 60 * 1.1515;
		$unit  = strtoupper($unit);
		if ($unit == "K") {
			return ($miles * 1.609344);
		} else if ($unit == "N") {
		  	return ($miles * 0.8684);
		} else {
			return $miles;
		}
	}
}

//use for ajax request
if(!function_exists('fs_search_by_zip')){
	function fs_search_by_zip() {
		$args = array(
		    'post_type' => 'store_locator'
		);
		// pending
	    $obituary_query = new WP_Query($args);
	    $geoDataArray = [];
	    while ($obituary_query->have_posts()) : $obituary_query->the_post(); 
        	$geoDataArray[] = array(
				'title'     => get_the_title(),
				'short_des' => substr(get_post_custom_values('_fs_short_des')[0],0,100),
				'address'   => get_post_custom_values('_fs_address')[0],
				'city'      => get_post_custom_values('_fs_city')[0],
				'state'     => get_post_custom_values('_fs_state')[0],
				'zip'       => get_post_custom_values('_fs_zip')[0],
				'lat'       => get_post_custom_values('_fs_lat')[0],
				'lon'       => get_post_custom_values('_fs_long')[0],
				'link'      => get_post_custom_values('_fs_link')[0],
				'id'        => get_the_ID(),
				'thumbnail' => get_the_post_thumbnail_url()
			);
	    endwhile;

	    $lat1 = $_POST['data']['lat'];
	    $lon1 = $_POST['data']['lng'];
	    $radius = $_POST['data']['radius'];
		$matchContractor 	= array();
	    //print_r($geoDataArray);exit;
		foreach ($geoDataArray as $key => $geoData) {
			$lat2 = $geoData['lat'];
			$lon2 = $geoData['lon'];
			$geoData['distance'] = fs_distance($lat1, $lon1, $lat2, $lon2, "M");
			$geoData['radius'] = $radius;
	        if($geoData['distance'] < $radius){
	        	$matchContractor[] = $geoData;
	        }            
		}
		echo json_encode($matchContractor); exit;
	}
}

if(!function_exists('searchInit')){
	function searchInit($text)	//search initial text in titles
	{
		//return $text;
		$reg = "/^".$_POST['data']['q']."/i";	//initial case insensitive searching
		return (bool)@preg_match($reg, $text['title']);
	}
}

if(!function_exists('fs_search_by_leaflet')){
	function fs_search_by_leaflet(){
		if(!isset($_POST['data']['q']) or empty($_POST['data']['q']))
		die( json_encode(array('ok'=>0, 'errmsg'=>'specify q parameter') ) );

		if(isset($_POST['data']['q']))	//SIMULATE A BIG DATABASE, for ajax-bulk.html example
			$data = json_decode( file_get_contents(plugin_dir_path(__FILE__).'../assets/js/cities15000.json'), true);
		//load big data store, cities15000.json (about 14000 records)

		$fdata = array_filter($data, 'searchInit');	//filter data
		$fdata = array_values($fdata);	//reset $fdata indexs
		$JSON = json_encode($fdata,true);

		#if($_SERVER['REMOTE_ADDR']=='127.0.0.1') sleep(1);
		//simulate connection latency for localhost tests
		@header("Content-type: application/json; charset=utf-8");

		if(isset($_POST['callback']) and !empty($_POST['callback']))	//support for JSONP request
			echo $_POST['callback']."($JSON)";
		else
			echo $JSON;	//AJAX request
		exit;
	}
}

//submenu view
if(!function_exists('fs_store_locator_setting')){
	function fs_store_locator_setting() {	
		if(!empty($_POST) && !empty(fs_sanatizer($_POST))){
			$upload_icon = $_FILES['icon'];
            if(!empty($upload_icon['type'])){
				list($width, $height) = getimagesize($_FILES['icon']['tmp_name']);
				
				if($width == 20 && $height == 40 && $upload_icon['type'] == 'image/png'){
					$upload_overrides = array( 'test_form' => false );
					$movefile = wp_handle_upload( $upload_icon, $upload_overrides );

					if ( $movefile && ! isset($movefile['error'] )) {
						update_option( 'fs-setting-zoom', $_POST['zoom'], 'yes' );
						update_option( 'fs-setting-lat', $_POST['lat'], 'yes' );
						update_option( 'fs-setting-long', $_POST['long'], 'yes' );
					    update_option( 'fs-setting-icon', $movefile['url'], 'yes' );
					    $main_message = "Data updated successfully";
					} else {
					     update_option( 'fs-setting-icon', '', 'yes' );
					}
				}else{
					$message = 'Only 20*40 (png) image is allowed.';
				}
			}else{
				update_option( 'fs-setting-zoom', $_POST['zoom'], 'yes' );
				update_option( 'fs-setting-lat', $_POST['lat'], 'yes' );
				update_option( 'fs-setting-long', $_POST['long'], 'yes' );
			    $main_message = "Data updated successfully";
			}
		}
		wp_register_style('fs-front-map', FS_BASE_URL.'assets/css/fs-map.css');
		wp_enqueue_style('fs-front-map');
		include dirname( __FILE__ ) . '\template\admin\fs-stores-setting.php';
	}
}

/**
* Sanatize setting form Field
* @param $input all input array 
*/
if(!function_exists('fs_sanatizer')){
	function fs_sanatizer($input){
		if(isset($input['zoom']))
			$input['zoom'] = sanitize_text_field( $input['zoom'] );
		if(isset($input['lat']))
			$input['lat'] = sanitize_text_field( $input['lat'] );
		if(isset($input['long']))
			$input['long'] = sanitize_text_field( $input['long'] );
		return $input;
	} 
}

//Add Support link
if(!function_exists('add_support_action_links')){
	function add_support_action_links ( $links ) {
		$mylinks = array(
			'<a href="https://www.fudugo.com/contact/" target="_blank">Support</a>',
		);
		return array_merge( $links, $mylinks );
	}
}

//Add Setting Link
if(!function_exists('add_setting_action_links')){
	function add_setting_action_links ( $links ) {
		$mylinks = array(
			'<a href="' . admin_url( 'edit.php?post_type=store_locator&page=store-locator-setting' ) . '">Settings</a>',
		);
		return array_merge( $links, $mylinks );
	}
}


